#pragma once
#include <QThread>
#include <QDebug>
#include <QDateTime>
#include <opencv2/opencv.hpp>
#include <opencv2/imgproc/types_c.h>
#include <atomic>
#include <mutex>
#include "common.h"
#include "SyncQueue.h"

#include <QUdpSocket>

#define SUCCESS 0
#define NO_LOGIN 1
#define UNKICK_FAIL 2
#define UNKICK_OK 3
#define DEBUG_EN_STILL_WORK 4
#define DEBUG_DIS_STILL_WORK 5
#define DEBUG_EN_FAIL 6
#define DEBUG_DIS_FAIL 7
#define DEBUG_EN 8
#define DEBUG_DIS 9
#define KICK_FAIL 10
#define LOGIN_IN 11
#define PSW_ERROR 12
#define NEED_LOGIN 13
#define CHECK_WORKSTATE 14
#define UNLOCK_OK 15
#define LOCK_OK 16
#define STILL_DEBUG 17
#define KICK_OK 18
#define GETSETTING 19
#define CANSETCONF 20
#define HANDSHAKE 40
#define WORK 21
#define NO_WORK 22

#define image_width 80
#define image_heigh 60

#define info_frame 1
#define speed_frame 2
#define kick_frame 3
#define ok_frame 4
#define ng_frame 5
#define image_frame 6
#define total_frame 7

class _UDPSendInfo
{
public:
	int FrameID;
	int index;
	cv::Mat image;
	int cnt;
	long Total;
	QString JD;
	QString timecost;
	int ok;
	int ng;
	QString speed;
	int Kick[NumberOfSupportedCameras];

	_UDPSendInfo()
	{
		FrameID = 0;
		index = 0;
		image = cv::Mat(image_width, image_heigh, CV_8UC3, cv::Scalar(0,0,0));
		Total = 0;
		JD = QString("0,0,0");
		timecost = QString("0ms");;
		ok = false;
		ng = false;
		speed = QString(" ");
		for(int i=0;i<NumberOfSupportedCameras;i++)Kick[i]=0;
	}
};

class threadSend : public QThread
{
public:
	QString ip;
	int dataport;
	int imageport;
	threadSend(QObject* o = nullptr) :QThread(o)
	{
		isLoop = true;
	}

	~threadSend()
	{
		stop();
		_UDPSendInfo UDPSendInfo;
		Local_UDP_Info_queue->put(UDPSendInfo);
		quit();
		wait();
	}
	void stop();

protected:
	void run();

public:
	void init(SyncQueue<_UDPSendInfo> *p_UDP_Info_queue,std::string IP,int port);
	void start_work();
	
	void sendData(_UDPSendInfo *UDPSendInfo,int port);
	void sendData(QString data, int port);
	void sendImage(_UDPSendInfo *UDPSendInfo,int port);
	void sendSpeed(_UDPSendInfo *UDPSendInfo,int port);
	void sendKick(_UDPSendInfo *UDPSendInfo,int port);
	void sendOK(_UDPSendInfo *UDPSendInfo,int port);
	void sendNG(_UDPSendInfo *UDPSendInfo,int port);
	void sendTotal(_UDPSendInfo *UDPSendInfo,int port);
public:
	SyncQueue<_UDPSendInfo> *Local_UDP_Info_queue;
	std::atomic_bool isLoop = { 0 };
	QUdpSocket mSocket;
};
